%problem tri teles reseny Runge-Kuttovou metodou 4. radu
clear
clc

cyklus = 0;

hold on;
axis([-640 640 -350 350]); 
axis equal;

%vstupni podminky:

m1=1050; m2=4; p2x=150; p2y=0; v2x=0; v2y=2.5; m3=0; p3x=400; p3y=-60; v3x=-1; v3y=-0.3; %puvodn PROG
%m1=2000; m2=0; p2x=80; p2y=0; v2x=0; v2y=-5; m3=0; p3x=-80; p3y=0; v3x=0; v3y=5*1.414;  %kruhov a parabolick drha
%m1=1000; m2=0; p2x=250; p2y=0; v2x=0; v2y=-1; m3=0; p3x=1000; p3y=50; v3x=-5; v3y=0;    %eliptick a hyperbolick drha
%m1=0; m2=800; p2x=-30; p2y=0; v2x=0; v2y=1; m3=800; p3x=370; p3y=0; v3x=0; v3y=-1;      %spec. dve telesa (a)
%m1=1000; m2=10; p2x=92; p2y=0; v2x=0; v2y=3/2; m3=10; p3x=150; p3y=0; v3x=0; v3y=2.5;   %vzjemn graviten vliv dvou velkch planet
%m1=1000; m2=324; p2x=200; p2y=0; v2x=0; v2y=2; m3=4; p3x=216; p3y=0; v3x=0; v3y=7;      %obeh dvojplanety kolem Slunce

%m1=; m2=; p2x=; p2y=; v2x=; v2y=; m3=; p3x=; p3y=; v3x=; v3y=;%


y=[
    p2x
    v2x
    p2y
    v2y
    p3x
    v3x
    p3y
    v3y
];

%volba kroku
h=0.9;
h2=h/2;
h6=h/6;

r1x=0;
r1y=0;

scale = 1.3456;
j1 = 149;
i1 = 175;
%------------------------------------

if(m1 > 0)
    circle(j1,i1,9)
end

%while(0==0)% <---------------------
for q=1:1e5

cyklus = cyklus + 1;
if(cyklus == 50)
    pause;
    cyklus = 0;
end
    
jj2 = j1 + round(y(1));
ii2 = i1 - round(y(3)/scale);
jj3 = j1 + round(y(5));
ii3 = i1 - round(y(7)/scale);

j2 = j1 + round(y(1));
i2 = i1 - round(y(3)/scale);
j3 = j1 + round(y(5));
i3 = i1 - round(y(7)/scale);

planet(j2,i2,'c');
planet(jj2,ii2,'k');

if(y(2) > 0)
    plot(jj2,ii2,'b');
else
    plot(jj2+1,ii2,'b');
end

%planet(j3,i3,'m');
%planet(jj3,ii3,'k');

if(y(6) > 0)
    %plot(jj3,ii3,'r');
else
    %plot(jj3+1,ii3,'r');
end

jj2 = j2;
ii2 = i2;
jj3 = j3;
ii3 = i3;


%metoda Runge-Kutta
n=8;
for i=1:n
     k1(i) = f(i,y,m1,m2,m3);
      z(i) = y(i)+h2*k1(i);
     k2(i) = f(i,y,m1,m2,m3);
      z(i) = y(i)+h2*k2(i);
     k3(i) = f(i,y,m1,m2,m3);
      z(i) = y(i)+h*k3(i);
     k4(i) = f(i,y,m1,m2,m3);
 end
 for i=1:n
     y(i) = y(i)+h6*(k1(i)+2*k2(i)+2*k3(i)+k4(i));
 end    
     
     


end%while <------------------------------